org.apache.maven.project

## Class MavenProject

- java.lang.Object
- - org.apache.maven.project.MavenProject

All Implemented Interfaces:
  java.lang.Cloneable

    public class MavenProject
    extends java.lang.Object
    implements java.lang.Cloneable

The concern of the project is provide runtime values based on the model.

The values in the model remain untouched but during the process of building a project notions like inheritance and interpolation can be added. This allows to have an entity which is useful in a runtime while preserving the model so that it can be marshalled and unmarshalled without being tainted by runtime requirements.

We need to leave the model intact because we don't want the following:

1. We don't want interpolated values being written back into the model.
2. We don't want inherited values being written back into the model.

### Field Summary

Fields
`static java.lang.String` `EMPTY_PROJECT_ARTIFACT_ID`
`static java.lang.String` `EMPTY_PROJECT_GROUP_ID`
`static java.lang.String` `EMPTY_PROJECT_VERSION`

### Constructor Summary

Constructors
Constructor and Description
`MavenProject()`
`MavenProject(Model model)`
`MavenProject(Model model, Logger logger)`

### Method Summary

Methods
`void` `addAttachedArtifact(Artifact artifact)`
`void` `addCompileSourceRoot(java.lang.String path)`
`void` `addContributor(Contributor contributor)`
`void` `addDeveloper(Developer developer)`
`void` `addLicense(License license)`
`void` `addMailingList(MailingList mailingList)`
`void` `addPlugin(Plugin plugin)`
`void` `addProjectReference(MavenProject project)`
`void` `addResource(Resource resource)`
`void` `addScriptSourceRoot(java.lang.String path)`
`void` `addTestCompileSourceRoot(java.lang.String path)`
`void` `addTestResource(Resource testResource)`
`void` `attachArtifact(java.lang.String type, java.lang.String classifier, java.io.File file)` Deprecated. Use MavenProjectHelper.attachArtifact(..) instead.
`void` `clearRestorableBuild()`
`void` `clearRestorableRoots()`
`java.lang.Object` `clone()`
`java.util.Set` `createArtifacts(ArtifactFactory artifactFactory, java.lang.String inheritedScope, ArtifactFilter dependencyFilter)`
`boolean` `equals(java.lang.Object other)`
`java.util.List` `getActiveProfiles()`
`Artifact` `getArtifact()`
`java.lang.String` `getArtifactId()`
`java.util.Map` `getArtifactMap()`
`java.util.Set` `getArtifacts()` All dependencies that this project has, including transitive ones.
`java.util.List` `getAttachedArtifacts()`
`java.io.File` `getBasedir()`
`Build` `getBuild()`
`java.util.List` `getBuildExtensions()`
`java.util.List` `getBuildPlugins()`
`CiManagement` `getCiManagement()`
`java.util.List` `getCollectedProjects()`
`java.util.List` `getCompileArtifacts()`
`java.util.List` `getCompileClasspathElements()`
`java.util.List` `getCompileDependencies()`
`java.util.List` `getCompileSourceRoots()`
`java.util.List` `getContributors()`
`java.lang.String` `getDefaultGoal()`
`java.util.List` `getDependencies()`
`java.util.Set` `getDependencyArtifacts()` Direct dependencies that this project has.
`DependencyManagement` `getDependencyManagement()`
`java.lang.String` `getDescription()`
`java.util.List` `getDevelopers()`
`DistributionManagement` `getDistributionManagement()`
`ArtifactRepository` `getDistributionManagementArtifactRepository()`
`Build` `getDynamicBuild()`
`java.util.List` `getDynamicCompileSourceRoots()`
`java.util.List` `getDynamicScriptSourceRoots()`
`java.util.List` `getDynamicTestCompileSourceRoots()`
`MavenProject` `getExecutionProject()`
`java.util.Map` `getExtensionArtifactMap()`
`java.util.Set` `getExtensionArtifacts()`
`java.io.File` `getFile()`
`java.util.List` `getFilters()`
`Xpp3Dom` `getGoalConfiguration(java.lang.String pluginGroupId, java.lang.String pluginArtifactId, java.lang.String executionId, java.lang.String goalId)`
`java.lang.String` `getGroupId()`
`java.lang.String` `getId()`
`java.lang.String` `getInceptionYear()`
`IssueManagement` `getIssueManagement()`
`java.util.List` `getLicenses()`
`java.util.List` `getMailingLists()`
`java.util.Map` `getManagedVersionMap()`
`Model` `getModel()`
`java.lang.String` `getModelVersion()`
`java.lang.String` `getModulePathAdjustment(MavenProject moduleProject)`
`java.util.List` `getModules()`
`java.lang.String` `getName()`
`Organization` `getOrganization()`
`Build` `getOriginalInterpolatedBuild()`
`java.util.List` `getOriginalInterpolatedCompileSourceRoots()`
`java.util.List` `getOriginalInterpolatedScriptSourceRoots()`
`java.util.List` `getOriginalInterpolatedTestCompileSourceRoots()`
`Model` `getOriginalModel()`
`java.lang.String` `getPackaging()`
`MavenProject` `getParent()`
`Artifact` `getParentArtifact()`
`java.util.Map` `getPluginArtifactMap()`
`java.util.List` `getPluginArtifactRepositories()`
`java.util.Set` `getPluginArtifacts()`
`PluginManagement` `getPluginManagement()`
`java.util.List` `getPluginRepositories()`
`Prerequisites` `getPrerequisites()`
`java.io.File` `getPreservedBasedir()`
`java.util.Properties` `getPreservedProperties()`
`ProjectBuilderConfiguration` `getProjectBuilderConfiguration()` Retrieve the `ProjectBuilderConfiguration` instance used to construct this MavenProject instance.
`static java.lang.String` `getProjectReferenceId(java.lang.String groupId, java.lang.String artifactId, java.lang.String version)`
`java.util.Map` `getProjectReferences()`
`java.util.Properties` `getProperties()`
`protected ArtifactRepository` `getReleaseArtifactRepository()`
`java.util.List` `getRemoteArtifactRepositories()`
`java.util.Map` `getReportArtifactMap()`
`java.util.Set` `getReportArtifacts()`
`Xpp3Dom` `getReportConfiguration(java.lang.String pluginGroupId, java.lang.String pluginArtifactId, java.lang.String reportSetId)`
`Reporting` `getReporting()`
`java.util.List` `getReportPlugins()`
`java.util.List` `getRepositories()`
`java.util.List` `getResources()`
`java.util.List` `getRuntimeArtifacts()`
`java.util.List` `getRuntimeClasspathElements()`
`java.util.List` `getRuntimeDependencies()`
`Scm` `getScm()`
`java.util.List` `getScriptSourceRoots()`
`protected ArtifactRepository` `getSnapshotArtifactRepository()`
`java.util.List` `getSystemArtifacts()`
`java.util.List` `getSystemClasspathElements()`
`java.util.List` `getSystemDependencies()`
`java.util.List` `getTestArtifacts()`
`java.util.List` `getTestClasspathElements()`
`java.util.List` `getTestCompileSourceRoots()`
`java.util.List` `getTestDependencies()`
`java.util.List` `getTestResources()`
`java.lang.String` `getUrl()`
`java.lang.String` `getVersion()`
`int` `hashCode()`
`boolean` `hasParent()`
`void` `injectPluginManagementInfo(Plugin plugin)`
`boolean` `isConcrete()`
`boolean` `isExecutionRoot()`
`void` `preserveBasedir()`
`void` `preserveBuild(Build originalInterpolatedBuild)`
`void` `preserveCompileSourceRoots(java.util.List originalInterpolatedCompileSourceRoots)`
`void` `preserveProperties()`
`void` `preserveScriptSourceRoots(java.util.List originalInterpolatedScriptSourceRoots)`
`void` `preserveTestCompileSourceRoots(java.util.List originalInterpolatedTestCompileSourceRoots)`
`Artifact` `replaceWithActiveArtifact(Artifact pluginArtifact)`
`void` `resolveActiveArtifacts()`
`void` `setActiveProfiles(java.util.List activeProfiles)`
`void` `setArtifact(Artifact artifact)`
`void` `setArtifactId(java.lang.String artifactId)`
`void` `setArtifacts(java.util.Set artifacts)`
`protected void` `setAttachedArtifacts(java.util.List attachedArtifacts)`
`void` `setBasedir(java.io.File basedir)`
`void` `setBuild(Build build)`
`void` `setCiManagement(CiManagement ciManagement)`
`void` `setCollectedProjects(java.util.List collectedProjects)`
`protected void` `setCompileSourceRoots(java.util.List compileSourceRoots)`
`void` `setConcrete(boolean concrete)`
`void` `setContributors(java.util.List contributors)`
`void` `setDependencies(java.util.List dependencies)`
`void` `setDependencyArtifacts(java.util.Set dependencyArtifacts)`
`void` `setDescription(java.lang.String description)`
`void` `setDevelopers(java.util.List developers)`
`void` `setDistributionManagement(DistributionManagement distributionManagement)`
`protected void` `setDynamicBuild(Build dynamicBuild)`
`protected void` `setDynamicCompileSourceRoots(java.util.List dynamicCompileSourceRoots)`
`protected void` `setDynamicScriptSourceRoots(java.util.List dynamicScriptSourceRoots)`
`protected void` `setDynamicTestCompileSourceRoots(java.util.List dynamicTestCompileSourceRoots)`
`void` `setExecutionProject(MavenProject executionProject)`
`void` `setExecutionRoot(boolean executionRoot)`
`void` `setExtensionArtifacts(java.util.Set extensionArtifacts)`
`void` `setFile(java.io.File file)`
`void` `setGroupId(java.lang.String groupId)`
`void` `setInceptionYear(java.lang.String inceptionYear)`
`void` `setIssueManagement(IssueManagement issueManagement)`
`void` `setLicenses(java.util.List licenses)`
`void` `setLogger(Logger logger)`
`void` `setMailingLists(java.util.List mailingLists)`
`void` `setManagedVersionMap(java.util.Map map)`
`protected void` `setModel(Model model)`
`void` `setModelVersion(java.lang.String pomVersion)`
`void` `setName(java.lang.String name)`
`void` `setOrganization(Organization organization)`
`protected void` `setOriginalInterpolatedBuild(Build originalInterpolatedBuild)`
`protected void` `setOriginalInterpolatedCompileSourceRoots(java.util.List originalInterpolatedCompileSourceRoots)`
`protected void` `setOriginalInterpolatedScriptSourceRoots(java.util.List originalInterpolatedScriptSourceRoots)`
`protected void` `setOriginalInterpolatedTestCompileSourceRoots(java.util.List originalInterpolatedTestCompileSourceRoots)`
`void` `setOriginalModel(Model originalModel)`
`void` `setPackaging(java.lang.String packaging)`
`void` `setParent(MavenProject parent)`
`void` `setParentArtifact(Artifact parentArtifact)`
`void` `setPluginArtifactRepositories(java.util.List pluginArtifactRepositories)`
`void` `setPluginArtifacts(java.util.Set pluginArtifacts)`
`void` `setProjectBuilderConfiguration(ProjectBuilderConfiguration projectBuilderConfiguration)` Set the `ProjectBuilderConfiguration` instance used to construct this MavenProject instance.
`void` `setReleaseArtifactRepository(ArtifactRepository releaseArtifactRepository)`
`void` `setRemoteArtifactRepositories(java.util.List remoteArtifactRepositories)`
`void` `setReportArtifacts(java.util.Set reportArtifacts)`
`void` `setReporting(Reporting reporting)`
`void` `setScm(Scm scm)`
`protected void` `setScriptSourceRoots(java.util.List scriptSourceRoots)`
`void` `setSnapshotArtifactRepository(ArtifactRepository snapshotArtifactRepository)`
`protected void` `setTestCompileSourceRoots(java.util.List testCompileSourceRoots)`
`void` `setUrl(java.lang.String url)`
`void` `setVersion(java.lang.String version)`
`java.lang.String` `toString()` Default toString
`void` `writeModel(java.io.Writer writer)`
`void` `writeOriginalModel(java.io.Writer writer)`

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### EMPTY_PROJECT_GROUP_ID

    public static final java.lang.String EMPTY_PROJECT_GROUP_ID

See Also:
  Constant Field Values

#### EMPTY_PROJECT_ARTIFACT_ID

    public static final java.lang.String EMPTY_PROJECT_ARTIFACT_ID

See Also:
  Constant Field Values

#### EMPTY_PROJECT_VERSION

    public static final java.lang.String EMPTY_PROJECT_VERSION

See Also:
  Constant Field Values

### Constructor Detail

#### MavenProject

    public MavenProject()

#### MavenProject

    public MavenProject(Model model)

#### MavenProject

    public MavenProject(Model model,
                Logger logger)

### Method Detail

#### getModulePathAdjustment

    public java.lang.String getModulePathAdjustment(MavenProject moduleProject)
                                             throws java.io.IOException

Throws:
  `java.io.IOException`

#### getArtifact

    public Artifact getArtifact()

#### setArtifact

    public void setArtifact(Artifact artifact)

#### getModel

    public Model getModel()

#### getParent

    public MavenProject getParent()

#### setParent

    public void setParent(MavenProject parent)

#### setRemoteArtifactRepositories

    public void setRemoteArtifactRepositories(java.util.List remoteArtifactRepositories)

#### getRemoteArtifactRepositories

    public java.util.List getRemoteArtifactRepositories()

#### hasParent

    public boolean hasParent()

#### getFile

    public java.io.File getFile()

#### setFile

    public void setFile(java.io.File file)

#### setBasedir

    public void setBasedir(java.io.File basedir)

#### getBasedir

    public java.io.File getBasedir()

#### setDependencies

    public void setDependencies(java.util.List dependencies)

#### getDependencies

    public java.util.List getDependencies()

#### getDependencyManagement

    public DependencyManagement getDependencyManagement()

#### addCompileSourceRoot

    public void addCompileSourceRoot(java.lang.String path)

#### addScriptSourceRoot

    public void addScriptSourceRoot(java.lang.String path)

#### addTestCompileSourceRoot

    public void addTestCompileSourceRoot(java.lang.String path)

#### getCompileSourceRoots

    public java.util.List getCompileSourceRoots()

#### getScriptSourceRoots

    public java.util.List getScriptSourceRoots()

#### getTestCompileSourceRoots

    public java.util.List getTestCompileSourceRoots()

#### getCompileClasspathElements

    public java.util.List getCompileClasspathElements()
                                               throws DependencyResolutionRequiredException

Throws:
  `DependencyResolutionRequiredException`

#### getCompileArtifacts

    public java.util.List getCompileArtifacts()

#### getCompileDependencies

    public java.util.List getCompileDependencies()

#### getTestClasspathElements

    public java.util.List getTestClasspathElements()
                                            throws DependencyResolutionRequiredException

Throws:
  `DependencyResolutionRequiredException`

#### getTestArtifacts

    public java.util.List getTestArtifacts()

#### getTestDependencies

    public java.util.List getTestDependencies()

#### getRuntimeClasspathElements

    public java.util.List getRuntimeClasspathElements()
                                               throws DependencyResolutionRequiredException

Throws:
  `DependencyResolutionRequiredException`

#### getRuntimeArtifacts

    public java.util.List getRuntimeArtifacts()

#### getRuntimeDependencies

    public java.util.List getRuntimeDependencies()

#### getSystemClasspathElements

    public java.util.List getSystemClasspathElements()
                                              throws DependencyResolutionRequiredException

Throws:
  `DependencyResolutionRequiredException`

#### getSystemArtifacts

    public java.util.List getSystemArtifacts()

#### getSystemDependencies

    public java.util.List getSystemDependencies()

#### setModelVersion

    public void setModelVersion(java.lang.String pomVersion)

#### getModelVersion

    public java.lang.String getModelVersion()

#### getId

    public java.lang.String getId()

#### setGroupId

    public void setGroupId(java.lang.String groupId)

#### getGroupId

    public java.lang.String getGroupId()

#### setArtifactId

    public void setArtifactId(java.lang.String artifactId)

#### getArtifactId

    public java.lang.String getArtifactId()

#### setName

    public void setName(java.lang.String name)

#### getName

    public java.lang.String getName()

#### setVersion

    public void setVersion(java.lang.String version)

#### getVersion

    public java.lang.String getVersion()

#### getPackaging

    public java.lang.String getPackaging()

#### setPackaging

    public void setPackaging(java.lang.String packaging)

#### setInceptionYear

    public void setInceptionYear(java.lang.String inceptionYear)

#### getInceptionYear

    public java.lang.String getInceptionYear()

#### setUrl

    public void setUrl(java.lang.String url)

#### getUrl

    public java.lang.String getUrl()

#### getPrerequisites

    public Prerequisites getPrerequisites()

#### setIssueManagement

    public void setIssueManagement(IssueManagement issueManagement)

#### getCiManagement

    public CiManagement getCiManagement()

#### setCiManagement

    public void setCiManagement(CiManagement ciManagement)

#### getIssueManagement

    public IssueManagement getIssueManagement()

#### setDistributionManagement

    public void setDistributionManagement(DistributionManagement distributionManagement)

#### getDistributionManagement

    public DistributionManagement getDistributionManagement()

#### setDescription

    public void setDescription(java.lang.String description)

#### getDescription

    public java.lang.String getDescription()

#### setOrganization

    public void setOrganization(Organization organization)

#### getOrganization

    public Organization getOrganization()

#### setScm

    public void setScm(Scm scm)

#### getScm

    public Scm getScm()

#### setMailingLists

    public void setMailingLists(java.util.List mailingLists)

#### getMailingLists

    public java.util.List getMailingLists()

#### addMailingList

    public void addMailingList(MailingList mailingList)

#### setDevelopers

    public void setDevelopers(java.util.List developers)

#### getDevelopers

    public java.util.List getDevelopers()

#### addDeveloper

    public void addDeveloper(Developer developer)

#### setContributors

    public void setContributors(java.util.List contributors)

#### getContributors

    public java.util.List getContributors()

#### addContributor

    public void addContributor(Contributor contributor)

#### setBuild

    public void setBuild(Build build)

#### getBuild

    public Build getBuild()

#### getResources

    public java.util.List getResources()

#### getTestResources

    public java.util.List getTestResources()

#### addResource

    public void addResource(Resource resource)

#### addTestResource

    public void addTestResource(Resource testResource)

#### setReporting

    public void setReporting(Reporting reporting)

#### getReporting

    public Reporting getReporting()

#### setLicenses

    public void setLicenses(java.util.List licenses)

#### getLicenses

    public java.util.List getLicenses()

#### addLicense

    public void addLicense(License license)

#### setArtifacts

    public void setArtifacts(java.util.Set artifacts)

#### getArtifacts

    public java.util.Set getArtifacts()

All dependencies that this project has, including transitive ones. Contents are lazily populated, so depending on what phases have run dependencies in some scopes won't be included. eg. if only compile phase has run, dependencies with scope test won't be included.

Returns:
  `Set` < `Artifact` >
See Also:
  `to get only direct dependencies`

#### getArtifactMap

    public java.util.Map getArtifactMap()

#### setPluginArtifacts

    public void setPluginArtifacts(java.util.Set pluginArtifacts)

#### getPluginArtifacts

    public java.util.Set getPluginArtifacts()

#### getPluginArtifactMap

    public java.util.Map getPluginArtifactMap()

#### setReportArtifacts

    public void setReportArtifacts(java.util.Set reportArtifacts)

#### getReportArtifacts

    public java.util.Set getReportArtifacts()

#### getReportArtifactMap

    public java.util.Map getReportArtifactMap()

#### setExtensionArtifacts

    public void setExtensionArtifacts(java.util.Set extensionArtifacts)

#### getExtensionArtifacts

    public java.util.Set getExtensionArtifacts()

#### getExtensionArtifactMap

    public java.util.Map getExtensionArtifactMap()

#### setParentArtifact

    public void setParentArtifact(Artifact parentArtifact)

#### getParentArtifact

    public Artifact getParentArtifact()

#### getRepositories

    public java.util.List getRepositories()

#### getReportPlugins

    public java.util.List getReportPlugins()

#### getBuildPlugins

    public java.util.List getBuildPlugins()

#### getModules

    public java.util.List getModules()

#### getPluginManagement

    public PluginManagement getPluginManagement()

#### addPlugin

    public void addPlugin(Plugin plugin)

#### injectPluginManagementInfo

    public void injectPluginManagementInfo(Plugin plugin)

#### getCollectedProjects

    public java.util.List getCollectedProjects()

#### setCollectedProjects

    public void setCollectedProjects(java.util.List collectedProjects)

#### setPluginArtifactRepositories

    public void setPluginArtifactRepositories(java.util.List pluginArtifactRepositories)

#### getPluginArtifactRepositories

    public java.util.List getPluginArtifactRepositories()

Returns:
  a list of ArtifactRepository objects constructed from the Repository objects returned by getPluginRepositories.

#### getDistributionManagementArtifactRepository

    public ArtifactRepository getDistributionManagementArtifactRepository()

#### getPluginRepositories

    public java.util.List getPluginRepositories()

#### setActiveProfiles

    public void setActiveProfiles(java.util.List activeProfiles)

#### getActiveProfiles

    public java.util.List getActiveProfiles()

#### addAttachedArtifact

    public void addAttachedArtifact(Artifact artifact)

#### getAttachedArtifacts

    public java.util.List getAttachedArtifacts()

#### getGoalConfiguration

    public Xpp3Dom getGoalConfiguration(java.lang.String pluginGroupId,
                               java.lang.String pluginArtifactId,
                               java.lang.String executionId,
                               java.lang.String goalId)

#### getReportConfiguration

    public Xpp3Dom getReportConfiguration(java.lang.String pluginGroupId,
                                 java.lang.String pluginArtifactId,
                                 java.lang.String reportSetId)

#### getExecutionProject

    public MavenProject getExecutionProject()

#### setExecutionProject

    public void setExecutionProject(MavenProject executionProject)

#### writeModel

    public void writeModel(java.io.Writer writer)
                    throws java.io.IOException

Throws:
  `java.io.IOException`

#### writeOriginalModel

    public void writeOriginalModel(java.io.Writer writer)
                            throws java.io.IOException

Throws:
  `java.io.IOException`

#### getDependencyArtifacts

    public java.util.Set getDependencyArtifacts()

Direct dependencies that this project has.

Returns:
  `Set` < `Artifact` >
See Also:
  `to get all transitive dependencies`

#### setDependencyArtifacts

    public void setDependencyArtifacts(java.util.Set dependencyArtifacts)

#### setReleaseArtifactRepository

    public void setReleaseArtifactRepository(ArtifactRepository releaseArtifactRepository)

#### setSnapshotArtifactRepository

    public void setSnapshotArtifactRepository(ArtifactRepository snapshotArtifactRepository)

#### setOriginalModel

    public void setOriginalModel(Model originalModel)

#### getOriginalModel

    public Model getOriginalModel()

#### setManagedVersionMap

    public void setManagedVersionMap(java.util.Map map)

#### getManagedVersionMap

    public java.util.Map getManagedVersionMap()

#### equals

    public boolean equals(java.lang.Object other)

Overrides:
  `equals` in class `java.lang.Object`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `java.lang.Object`

#### getBuildExtensions

    public java.util.List getBuildExtensions()

#### createArtifacts

    public java.util.Set createArtifacts(ArtifactFactory artifactFactory,
                                java.lang.String inheritedScope,
                                ArtifactFilter dependencyFilter)
                                  throws InvalidDependencyVersionException

Returns:
  `Set` < `Artifact` >
Throws:
  `InvalidDependencyVersionException`

#### addProjectReference

    public void addProjectReference(MavenProject project)

#### getProjectReferenceId

    public static java.lang.String getProjectReferenceId(java.lang.String groupId,
                                         java.lang.String artifactId,
                                         java.lang.String version)

#### attachArtifact

    public void attachArtifact(java.lang.String type,
                      java.lang.String classifier,
                      java.io.File file)

Deprecated. Use MavenProjectHelper.attachArtifact(..) instead.

#### getProperties

    public java.util.Properties getProperties()

#### getFilters

    public java.util.List getFilters()

#### getProjectReferences

    public java.util.Map getProjectReferences()

#### isExecutionRoot

    public boolean isExecutionRoot()

#### setExecutionRoot

    public void setExecutionRoot(boolean executionRoot)

#### getDefaultGoal

    public java.lang.String getDefaultGoal()

#### setModel

    protected void setModel(Model model)

#### setAttachedArtifacts

    protected void setAttachedArtifacts(java.util.List attachedArtifacts)

#### setCompileSourceRoots

    protected void setCompileSourceRoots(java.util.List compileSourceRoots)

#### setTestCompileSourceRoots

    protected void setTestCompileSourceRoots(java.util.List testCompileSourceRoots)

#### setScriptSourceRoots

    protected void setScriptSourceRoots(java.util.List scriptSourceRoots)

#### getReleaseArtifactRepository

    protected ArtifactRepository getReleaseArtifactRepository()

#### getSnapshotArtifactRepository

    protected ArtifactRepository getSnapshotArtifactRepository()

#### resolveActiveArtifacts

    public void resolveActiveArtifacts()

#### replaceWithActiveArtifact

    public Artifact replaceWithActiveArtifact(Artifact pluginArtifact)

#### toString

    public java.lang.String toString()

Default toString

Overrides:
  `toString` in class `java.lang.Object`

#### clone

    public java.lang.Object clone()
                           throws java.lang.CloneNotSupportedException

Overrides:
  `clone` in class `java.lang.Object`
Throws:
  `java.lang.CloneNotSupportedException`
Since:
  2.0.9

#### isConcrete

    public boolean isConcrete()

#### setConcrete

    public void setConcrete(boolean concrete)

#### getDynamicBuild

    public Build getDynamicBuild()

#### getOriginalInterpolatedBuild

    public Build getOriginalInterpolatedBuild()

#### getDynamicCompileSourceRoots

    public java.util.List getDynamicCompileSourceRoots()

#### getOriginalInterpolatedCompileSourceRoots

    public java.util.List getOriginalInterpolatedCompileSourceRoots()

#### getDynamicTestCompileSourceRoots

    public java.util.List getDynamicTestCompileSourceRoots()

#### getOriginalInterpolatedTestCompileSourceRoots

    public java.util.List getOriginalInterpolatedTestCompileSourceRoots()

#### getDynamicScriptSourceRoots

    public java.util.List getDynamicScriptSourceRoots()

#### getOriginalInterpolatedScriptSourceRoots

    public java.util.List getOriginalInterpolatedScriptSourceRoots()

#### clearRestorableRoots

    public void clearRestorableRoots()

#### clearRestorableBuild

    public void clearRestorableBuild()

#### preserveCompileSourceRoots

    public void preserveCompileSourceRoots(java.util.List originalInterpolatedCompileSourceRoots)

#### preserveTestCompileSourceRoots

    public void preserveTestCompileSourceRoots(java.util.List originalInterpolatedTestCompileSourceRoots)

#### preserveScriptSourceRoots

    public void preserveScriptSourceRoots(java.util.List originalInterpolatedScriptSourceRoots)

#### preserveBuild

    public void preserveBuild(Build originalInterpolatedBuild)

#### setDynamicBuild

    protected void setDynamicBuild(Build dynamicBuild)

#### setOriginalInterpolatedBuild

    protected void setOriginalInterpolatedBuild(Build originalInterpolatedBuild)

#### setDynamicCompileSourceRoots

    protected void setDynamicCompileSourceRoots(java.util.List dynamicCompileSourceRoots)

#### setOriginalInterpolatedCompileSourceRoots

    protected void setOriginalInterpolatedCompileSourceRoots(java.util.List originalInterpolatedCompileSourceRoots)

#### setDynamicTestCompileSourceRoots

    protected void setDynamicTestCompileSourceRoots(java.util.List dynamicTestCompileSourceRoots)

#### setOriginalInterpolatedTestCompileSourceRoots

    protected void setOriginalInterpolatedTestCompileSourceRoots(java.util.List originalInterpolatedTestCompileSourceRoots)

#### setDynamicScriptSourceRoots

    protected void setDynamicScriptSourceRoots(java.util.List dynamicScriptSourceRoots)

#### setOriginalInterpolatedScriptSourceRoots

    protected void setOriginalInterpolatedScriptSourceRoots(java.util.List originalInterpolatedScriptSourceRoots)

#### getPreservedProperties

    public java.util.Properties getPreservedProperties()

#### preserveProperties

    public void preserveProperties()

#### getPreservedBasedir

    public java.io.File getPreservedBasedir()

#### preserveBasedir

    public void preserveBasedir()

#### setLogger

    public void setLogger(Logger logger)

#### getProjectBuilderConfiguration

    public ProjectBuilderConfiguration getProjectBuilderConfiguration()

Retrieve the `ProjectBuilderConfiguration` instance used to construct this MavenProject instance.

#### setProjectBuilderConfiguration

    public void setProjectBuilderConfiguration(ProjectBuilderConfiguration projectBuilderConfiguration)

Set the `ProjectBuilderConfiguration` instance used to construct this MavenProject instance.

Parameters:
  `projectBuilderConfiguration` -